#include <yangutil/sys/YangString.h>
#include <yangutil/yang_unistd.h>
#include <stdint.h>
#include <inttypes.h>
#include <stdlib.h>
#ifdef _WIN32
#include <random>
#define srandom srand
#define random rand
#endif
#include <yangutil/sys/YangTime.h>
#ifdef _MSC_VER
#include <windows.h>
#endif

 void skip_first_spaces(std::string& str)
{
    while (! str.empty() && str[0] == ' ') {
        str.erase(0, 1);
    }
}

vector<string> yang_split(string s, char ch) {
	size_t start = 0;
	int32_t len = 0;
	vector<string> ret;
	for (size_t i = 0; i < s.length(); i++) {
		if (s[i] == ch) {
			ret.push_back(s.substr(start, len));
			start = i + 1;
			len = 0;
		}
		else {
			len++;
		}
	}
	if (start < s.length())
		ret.push_back(s.substr(start, len));
	return ret;
}

std::vector<std::string> yang_splits(const std::string& str, const std::string& delim)
{
    std::vector<std::string> ret;
    size_t pre_pos = 0;
    std::string tmp;
    size_t pos = 0;
    do {
        pos = str.find(delim, pre_pos);
        tmp = str.substr(pre_pos, pos - pre_pos);
        ret.push_back(tmp);
        pre_pos = pos + delim.size();
    } while (pos != std::string::npos);

    return ret;
}

long yang_random() {
	static bool _random_contexttialized = false;
	if (!_random_contexttialized) {
		_random_contexttialized = true;
#ifdef _MSC_VER
        ::srandom((unsigned long) (yang_update_system_time() | (GetCurrentProcessId() << 13)));
#else
        ::srandom((unsigned long) (yang_update_system_time() | (getpid() << 13)));
#endif


	}

	return random();
}
std::string yang_int2str(int64_t value) {

	char tmp[22];
    snprintf(tmp, 22, "%" PRId64, value);
	return string(tmp);
}
std::string yang_random_str(int32_t len) {
	static string random_table =
			"01234567890123456789012345678901234567890123456789abcdefghijklmnopqrstuvwxyz";
	string ret;
	ret.reserve(len);
	for (int32_t i = 0; i < len; ++i) {
		ret.append(1, random_table[yang_random() % random_table.size()]);
	}

	return ret;
}
void yang_replace(std::string& strBig, const std::string& strsrc, const std::string& strdst)
{
	std::string::size_type pos = 0;
	std::string::size_type srclen = strsrc.size();
	std::string::size_type dstlen = strdst.size();

	while ((pos = strBig.find(strsrc, pos)) != std::string::npos)
	{
		strBig.replace(pos, srclen, strdst);
		pos += dstlen;
	}
}
